#!/bin/bash

# uninstall logic for XConnect Online Backup Manager 6.3.0.0
# The root privilege is required to uninstall the application

###############################################################################
#             S H U T - D O W N                 S E R V I C E S               #
###############################################################################

# Shutdown Scheduler
if [ -e "/Applications/XConnectOBM/ipc/Scheduler/running" ]; then
    echo "Shutdown Scheduler for XConnect Online Backup Manager"
    touch "/Applications/XConnectOBM/ipc/Scheduler/stop"
    echo "Wait 5 seconds before Scheduler exits"
    sleep 5
fi

# Shutdown AutoUpdateAgent
if [ -e "/Applications/XConnectOBM/aua/bin" ]; then
    echo "Shutdown AutoUpdateAgent for XConnect Online Backup Manager"
    sh "/Applications/XConnectOBM/aua/bin/shutdown.sh"
    echo "Wait 5 seconds before AutoUpdateAgent exits"
    sleep 5
fi

###############################################################################
#        T A S K K I L L       A L L      J A V A       P R O C E S S         #
###############################################################################

# Kill all running process
sh "/Applications/XConnectOBM/bin/taskkill" "/Applications/XConnectOBM/BackupManager.app"
sh "/Applications/XConnectOBM/bin/taskkill" "/Applications/XConnectOBM/bin/BackupManager.app"
sh "/Applications/XConnectOBM/bin/taskkill" "/Applications/XConnectOBM/jvm/bin/java"
sh "/Applications/XConnectOBM/bin/taskkill" "/Applications/XConnectOBM/aua/jvm/bin/java"

###############################################################################
#                 R E M O V E                   S E R V I C E S               #
###############################################################################

# Remove Scheduler
if [ -e "/Library/StartupItems/XConnectOBM" ]; then
    echo "Remove Scheduler for XConnect Online Backup Manager from service"
    rm -rf "/Library/StartupItems/XConnectOBM"
fi

# Remove AutoUpdateAgent
if [ -e "/Library/StartupItems/XConnectOBM-AutoUpdate" ]; then
    echo "Remove AutoUpdateAgent for XConnect Online Backup Manager from service"
    rm -rf "/Library/StartupItems/XConnectOBM-AutoUpdate"
fi

###############################################################################
#      R E M O V E        U S E R         D E S K T O P      L I N K          #
###############################################################################

# Remove Desktop Symbolic Link
find /Users -name Desktop -type d -maxdepth 3 -mindepth 2 | while read DESKTOP_PATH;
do
    if [ -e "${DESKTOP_PATH}/XConnectOBM" ]; then
        echo "Remove Desktop Link XConnectOBM from path ${DESKTOP_PATH}"
        rm -f "${DESKTOP_PATH}/XConnectOBM"
        echo "Removed XConnect Online Backup Manager Desktop Link"
    fi

    if [ -e "${DESKTOP_PATH}/XConnectOBM" ]; then
        echo "Remove Desktop Link XConnectOBM from path ${DESKTOP_PATH}"
        rm -f "${DESKTOP_PATH}/XConnectOBM"
        echo "Removed XConnect Online Backup Manager Desktop Link"
    fi
done

###############################################################################
#        R E M O V E           A P P L I C A T I O N           H O M E        #
###############################################################################

# Remove XConnect Online Backup Manager
cd /
if [ -e "/Applications/XConnectOBM" ]; then
    echo "Remove XConnect Online Backup Manager from Your Mac OS X"
    rm -rf "/Applications/XConnectOBM"
fi

###############################################################################
#        R E M O V E             M A C     O S        R E C E I P T S         #
###############################################################################

# Remove Mac OS X Receipts
if [ -e "/Library/Receipts/obm.pkg" ]; then
    echo "Remove Mac OS X Receipt for obm.pkg (Path: /Library/Receipts/obm.pkg)"
    rm -rf "/Library/Receipts/obm.pkg"
fi
